diff --git a/GNUmakefile b/GNUmakefile
index 16403d50..42533737 100644
--- a/GNUmakefile
+++ b/GNUmakefile
@@ -57,9 +58,13 @@ CFLAGS_DEBUG   := -O0 -g2 -Wall
 CFLAGS_RELEASE := $(if $(RPM_OPT_FLAGS), $(RPM_OPT_FLAGS), -O2 -DNDEBUG)
 CFLAGS_RELEASE += -DCAR_CHECK=0 -DCDR_CHECK=0
 
-CFLAGS += -DHAS_SOCKETS=$(if $(HAS_SOCKETS),1,0)
-CFLAGS += -DHAS_DLOPEN=$(if $(HAS_DLOPEN),1,0)
-CFLAGS += -DHAS_SANDBOX=$(if $(HAS_SECCOMP),1,0)
+CFLAGS += -DHAS_SOCKETS=$(if $(HAS_SOCKETS),$(HAS_SOCKETS),0)
+CFLAGS += -DHAS_DLOPEN=$(if $(HAS_DLOPEN),$(HAS_DLOPEN),0)
+CFLAGS += -DHAS_SANDBOX=$(if $(HAS_SECCOMP),$(HAS_SECCOMP),0)
+
+ifneq ($(HAS_MEMFD_CREATE),)
+CFLAGS += -DHAS_MEMFD_CREATE=$(HAS_MEMFD_CREATE)
+endif
 
 VERSION ?= $(shell echo `git describe --tags \`git rev-list --tags --max-count=1\``-`git rev-list HEAD --count`-`git log --pretty=format:'%h' -n 1`)
 
